<?php
$m = 'Vpn';
$berogui_path = '/usr/local/www/berogui';

/* [CHECKING SESSION] */
$newTarget = "/app/berogui/index.php?m=$m";
include("$berogui_path/includes/session.php");
unset($newTarget);

/* [CHECKING GET] */
unset($_GET);

/* [CHECKING POST] */
unset($_POST['submit']);
$exec_ajax = 1;

require_once("$berogui_path/includes/Helper/Helper.php");
$parameters = require("$berogui_path/modules/Vpn/vpn_parameters.php");
Helper::setDataValidator($parameters, $list_data, $options_data);

$data = Helper::sanitizePost($_POST['data'], $list_data, $exec_ajax, $invalid, $options_data);
unset($_POST['data']);

$list_post = [
	'action'				=> 'select',
	'idkey' 				=> 'int>=0',
	'isMainVpnExist'=> 'bool',
];

$options_post = [
	'action' => ['delete', 'save'],
];

$_POST = Helper::sanitizePost($_POST, $list_post, $exec_ajax, $invalid, $options_post);

$id = $_POST['idkey'];
$action = $_POST['action'];
$hasMainVpn = $_POST['isMainVpnExist'] == 1;

unset($_POST);

/* [EXECUTING AJAX] */
if (!$exec_ajax) {
	echo "<script>window.location='../../index.php?m=$m&error=1&request={$invalid['request']}&checkor={$invalid['checkor']}&key={$invalid['key']}'</script>";
	exit(1);
}

require_once("$berogui_path/includes/sbcApi.php");
$sbc_api = new sbcApi();

$sbcconf = parse_ini_file('/etc/beroNet/sbc.conf', true);
require_once('/usr/fallback/beroConf.php');

require_once('/usr/fallback/beroConf.php');
$bc = new beroConf('root');

require_once("$berogui_path/misc/database.php");
$ba = new beroAri();

switch ($action) {
case 'delete':
	// remove vpn server
	if ($ret = $sbc_api->deleteVpnServer($id)) {
		$error = json_decode($ret, true);
		echo "<script>window.location='../../index.php?m=$m&error=2&reason={$error['error']}'</script>";
		exit(1);
	}

	// update beroari
	$ba->delete("DELETE FROM sbc_vpns WHERE id='$id'");

	// update beroconf
	$update = [
		'lan-ipaddr' 	=> $sbcconf['SBCVM_IP'],
		'lan-netmask'	=> '255.255.255.0',
		'lan-mode'		=> 'single',
		'wan-ipaddr'	=> '',
		'wan-netmask' => '',
	];
	foreach ($update as $key => $value) {
		$bc->set('root', $key, $value);
	}
	break;
case 'save':
	// update beroari
	if ($hasMainVpn) {
		$ba->updateTable('sbc_vpns', $id, $data);
	}
	else {
		$ba->insertTable('sbc_vpns', $id, $data);
	}

	// update VPN settings using nodejs server
	if ($ret = $sbc_api->updateVpnServer($id, $data)) {
		$error = json_decode($ret, true);
		echo "<script>window.location='../../index.php?m=$m&error=2&reason={$error['error']}'</script>";
		exit(1);
	}

	// update beroconf
	$update = [
		'lan-ipaddr' 	=> Helper::getNetworkIpAddr('tun0'),
		'lan-netmask'	=> Helper::getNetworkMask('tun0'),
		'lan-mode'		=> 'lan-wan',
		'wan-ipaddr'	=> $sbcconf['SBCVM_IP'],
		'wan-netmask' => '255.255.255.0',
	];
	foreach ($update as $key => $value) {
		$bc->set('root', $key, $value);
	}
	break;
}

// yellow activate and redirect
Helper::activate(1);
if ($ba->is_error()) {
	echo "<script>alert('{$ba->error()}');</script>";
}
else {
	echo "<script>window.location='../../index.php?m=$m'</script>";
}

exit(0);
?>
